/** A panel of controls at the bottom: includes logo, a ChatPanel, and
    status-bar.  */


import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.Vector;
import java.util.Enumeration;


class BoardControls extends Panel
{
  GoGame game;
  GoBoard board;
  GoCanvas canvas;
  TextField messagearea;
  TextField chatsend;
  Panel syspanel, eastpanel, westpanel;
  ChatPanel chatpanel;

  public BoardControls(GoGame game, GoCanvas canvas, GoBoard board)
  {
    this.game = game;
    this.canvas = canvas;
    this.board = board;

    setBackground(new Color(160, 0, 0)); // nice maroon background

    // Create system-message subpanel
    syspanel = new Panel();
    syspanel.setLayout(new FlowLayout(FlowLayout.LEFT));
    syspanel.setBackground(new Color(160, 0, 0));
    Label syslabel = new Label("Game Status: ");
    syslabel.setForeground(Color.white);
    syslabel.setFont(game.bk_font);
    syspanel.add(syslabel);
    syspanel.add(messagearea = new TextField("Starting game...", 20));
    messagearea.setEditable(false);
    messagearea.setBackground(Color.gray);
    messagearea.setFont(game.bk_font);

    // Create chat subpanel
    chatpanel = new ChatPanel(game);

    // Divide controls into east and west panels

    eastpanel = new Panel();
    eastpanel.setLayout(new BorderLayout());
    eastpanel.add(chatpanel, "North");
    eastpanel.add(syspanel, "South");

    // Add the subpanels to our main BoardControls panel:
    
    setLayout(new BorderLayout());
    add(eastpanel, "Center");

  }

  /**  System message area is open to the world.  */

  public void DisplayMessage(String message) {
    messagearea.setText(message);
  }
}



//////////////////////////////////////////////////////////
// Don't think, just hit `y':
//
// local variables:
// eval: (load-file "bkgomagic.el")
// end:
//////////////////////////////////////////////////////////
