
/** A text widget for sending & receiving messages via MessagePasser
    (mini-IRC) */


import java.awt.*;
import java.awt.event.*;


public class ChatPanel extends Panel implements ActionListener 
{
  private TextArea chatarea;
  private Label chatlabel;
  private Canvas iconcanvas;
  private TextField chatsend;
  GoGame game;
  String logofile = "bkgo.jpg";
  Image bkgo_logo;

  public ChatPanel(GoGame game) 
  {
    this.game = game;

    // Load up the "bkgo" logo:
    if (game.applet_p) { // if applet, use applet.getImage(URL)
      bkgo_logo = game.parent_applet.getImage
	(game.parent_applet.getCodeBase(), logofile);
    }
    else {  //cd if application, read file from disk
      bkgo_logo = Toolkit.getDefaultToolkit().getImage(logofile);
    }

    iconcanvas = new Canvas();
    //    Graphics g = iconcanvas.getGraphics();
    //g.drawImage(bkgo_logo, 0, 0, iconcanvas);
    chatlabel = new Label("Chat Entry:");
    chatlabel.setForeground(Color.white);
    chatlabel.setFont(game.bk_font);
    chatsend = new TextField("Type here to chat.", 30);
    chatsend.setEditable(true);
    chatsend.setBackground(Color.white);
    chatsend.setFont(game.bk_font);

    chatarea = new TextArea("", 30, 50, TextArea.SCROLLBARS_VERTICAL_ONLY);
    chatarea.setEditable(false);
    chatarea.setBackground(Color.white);
    chatarea.setForeground(Color.blue);
    chatarea.setFont(game.bk_font_small);  // use the smaller bk_font
    chatarea.setColumns(50); // need to reset rows/cols after changing font!
    chatarea.setRows(30);

    Panel toppanel = new Panel(new FlowLayout(FlowLayout.LEFT));
    toppanel.setBackground(new Color(160, 0, 0));
    toppanel.add(chatarea);

    Panel bottompanel = new Panel(new FlowLayout(FlowLayout.LEFT));
    bottompanel.setBackground(new Color(160, 0, 0));
    bottompanel.add(chatlabel);
    bottompanel.add(chatsend);

    setLayout(new BorderLayout());
    setBackground(new Color(160, 0, 0));
    add(toppanel, "North");
    add(bottompanel, "South");


    // This class will handle the textfield's Action events.
    chatsend.addActionListener(this);

  }

  /**  Called by the outside world, when a message is received */ 

  public void opponent_append(String message) {
    chatarea.append(message + "\n");
    // awt.TextArea seems to autoscroll whenever we append.  Amazing!!
  }

  /**  If we need to clear the window */

  public void clear_window() {
    chatarea.setText("");
  }

  /** Our ActionListener interface (when player hits "enter") */

  public void actionPerformed(ActionEvent e) {
    String message = e.getActionCommand();
    chatsend.setText(null);
    game.mp.send_message("Message: " + game.player.name + ": " + message);
  }
}



//////////////////////////////////////////////////////////
// Don't think, just hit `y':
//
// local variables:
// eval: (load-file "bkgomagic.el")
// end:
//////////////////////////////////////////////////////////
